//+------------------------------------------------------------------+
//|                                         Esosa MACD Indicator.mq4 |
//|                                          Copyright  2008, Esosa |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Esosa"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 3
#property indicator_color1 LawnGreen
#property indicator_width1 4
#property indicator_color2 Red
#property indicator_width2 4
#property indicator_color3 White
#property indicator_width3 4

extern int FastEMA1=1;
extern int SlowEMA1=12;

extern int FastEMA2=1;
extern int SlowEMA2=12;

extern int FastEMA3=1;
extern int SlowEMA3=12;

double BlueBuffer[];
double YellowBuffer[];
double WhiteBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   //---- indicator buffers mapping
   SetIndexBuffer(0,BlueBuffer);
   SetIndexBuffer(1,YellowBuffer);
   SetIndexBuffer(2,WhiteBuffer);
   
   IndicatorShortName("TRIPLE EMA-CROSSOVERS");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
   {
      double MACD1   = iMACD(Symbol(),0,FastEMA1,SlowEMA1,1,0,0,i);
      double MACD2   = iMACD(Symbol(),0,FastEMA2,SlowEMA2,1,0,0,i);
      double MACD3   = iMACD(Symbol(),0,FastEMA3,SlowEMA3,1,0,0,i);
      
      BlueBuffer[i]=EMPTY_VALUE;
      YellowBuffer[i]=EMPTY_VALUE;
      WhiteBuffer[i]=EMPTY_VALUE;
      
      if(MACD1>0&&MACD2>0&&MACD3>0) BlueBuffer[i] = 1000;
      else if(MACD1<0&&MACD2<0&&MACD3<0) YellowBuffer[i] = 1000;
      else WhiteBuffer[i] = 1000; 
      
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+